/**
 * Created by xiaoqiang on 10/9/16.
 */
var Module = angular.module('Cutterman', [
    'ngRoute',
    'pascalprecht.translate'
  ]);
var VERSION = '1.2.4';
var VERSION_CODE = 124;
var APP_NAME = 'Sketch.Cutterman';
Module.config([
  '$routeProvider',
  function ($routeProvider) {
    $routeProvider.when('/login', {
      templateUrl: 'templates/login.html',
      controller: 'LoginController'
    }).when('/expire', {
      templateUrl: 'templates/expire.html',
      controller: 'ExpireController'
    }).when('/panel', {
      templateUrl: 'templates/panel.html',
      controller: 'PanelController'
    }).when('/user', {
      templateUrl: 'templates/user.html',
      controller: 'UserController'
    }).when('/setting', {
      templateUrl: 'templates/setting.html',
      controller: 'SettingController'
    });
  }
]);
Module.config([
  '$translateProvider',
  function ($translateProvider) {
    $translateProvider.translations('en', lang.i18n['en']);
    $translateProvider.translations('zh', lang.i18n['zh']);
    $translateProvider.preferredLanguage('zh');
  }
]);
Module.factory('User', function () {
  var User = function () {
      function User() {
        this.email = '';
        this.password = '';
        this.app = 'Sketch.Cutterman';
      }
      ;
      User.prototype.toJSON = function () {
        return {
          email: this.email,
          password: this.password,
          app: this.app,
          uid: this.uid,
          avatar: this.avatar,
          licence: this.licence,
          trial_start: this.trial_start
        };
      };
      User.prototype.fromJSON = function (json) {
        var jsonObj = JSON.parse(json);
        for (var propName in jsonObj) {
          this[propName] = jsonObj[propName];
        }
      };
      return User;
    }();
  return new User();
});
Module.controller('RootController', [
  '$scope',
  '$location',
  'User',
  function ($s, $location, User) {
    function init() {
      bridge.readFile('user.json').then(function (result) {
        User.fromJSON(result);
        checkTrial();
        $location.path('/panel');
        $s.$apply();
      }, function () {
        $location.path('/login');
        $s.$apply();
      });
    }
    $s.$on('LOGIN_SUCCESS', function (e, data) {
      User.fromJSON(data);
      bridge.saveFile('user.json', data);
      setTimeout(function () {
        $location.path('/panel');
        $s.$apply();
        checkTrial();
      }, 100);
    });
    $s.$on('LOGOUT_SUCCESS', function (e) {
      setTimeout(function () {
        $location.path('/login');
        $s.$apply();
      }, 100);
    });
    $s.$on('GO_PANEL', function (e, data) {
      setTimeout(function () {
        $location.path('/panel');
        $s.$apply();
      }, 100);
    });
    $s.$on('UPDATE_SETTING', function (e, data) {
      $s.$broadcast('UPDATE_CONFIGURE', data);
    });
    $s.$on('GO_SETTING', function (e, data) {
      setTimeout(function () {
        $location.path('/setting');
        $s.$apply();
      }, 100);
    });
    $s.$on('GO_USER', function (e, data) {
      setTimeout(function () {
        $location.path('/user');
        $s.$apply();
      }, 100);
    });
    $s.$on('TOAST', function (e, data) {
      $('#toast').html('<span>' + data + '</span>').show().animate({ top: '80px' }, 'fast', 'swing', function () {
        setTimeout(function () {
          $('#toast').animate({ top: '-50px' }, 'fast', 'swing', function () {
            $('#toast').hide();
          });
        }, 2000);
      });
    });
    function checkTrial() {
      if (User.licence == '') {
        var start = User.trial_start * 1000;
        var now = new Date().getTime();
        if (now - start > 15 * 24 * 3600 * 1000) {
          setTimeout(function () {
            $location.path('/expire');
            $s.$apply();
          }, 100);
        }
      }
    }
    init();
  }
]);