/**
 * Created by xiaoqiang on 10/10/16.
 */
var PanelController = Module.controller('PanelController', [
    '$scope',
    '$location',
    'User',
    '$translate',
    function ($s, $location, User, $translate) {
      var Target;
      (function (Target) {
        Target[Target['IOS'] = 0] = 'IOS';
        Target[Target['ANDROID'] = 1] = 'ANDROID';
        Target[Target['WEB'] = 2] = 'WEB';
      }(Target || (Target = {})));
      ;
      var Format;
      (function (Format) {
        Format[Format['PNG'] = 0] = 'PNG';
        Format[Format['JPG'] = 1] = 'JPG';
        Format[Format['PDF'] = 2] = 'PDF';
        Format[Format['SVG'] = 3] = 'SVG';
        Format[Format['TIFF'] = 4] = 'TIFF';
        Format[Format['EPS'] = 5] = 'EPS';
      }(Format || (Format = {})));
      ;
      var Png;
      (function (Png) {
        Png[Png['PNG24'] = 0] = 'PNG24';
        Png[Png['PNG8'] = 1] = 'PNG8';
      }(Png || (Png = {})));
      ;
      $s.target = Target.ANDROID;
      $s.configure = {
        ios: {
          width: '',
          height: '',
          format: Format.PNG,
          dpi: [
            1,
            1,
            0
          ],
          output: ''
        },
        android: {
          width: '',
          height: '',
          format: Format.PNG,
          dpi: [
            0,
            1,
            1,
            0,
            0
          ],
          output: ''
        },
        web: {
          width: '',
          height: '',
          format: Format.PNG,
          dpi: [1],
          output: ''
        }
      };
      $s.update = {
        update: 0,
        version_name: '0',
        download_url: 'http:/www.cutterman.cn',
        update_list: []
      };
      function init() {
        bridge.readFile('configure.json').then(function (result) {
          $s.configure = JSON.parse(result);
          $s.$apply();
        });
        checkUpdate();
      }
      $s.export = function () {
        bridge.saveFile('configure.json', JSON.stringify($s.configure));
        var target = Target[$s.target].toLocaleLowerCase();
        var setting = $s.configure[target];
        if (setting.output == '') {
          $translate(['select_output']).then(function (translations) {
            $s.$emit('TOAST', translations.select_output);
          });
          return;
        }
        var options = {
            target: $s.target,
            configure: $s.configure[target]
          };
        bridge.call('export', JSON.stringify(options), function (result) {
          console.log(result);
          if (result) {
            $s.$emit('TOAST', result);
          }
        });
      };
      $s.clearFixSize = function (target) {
        $s.configure[target]['width'] = '';
        $s.configure[target]['height'] = '';
      };
      $s.toggleDpiButton = function (target, index) {
        var item = $s.configure[target]['dpi'][index];
        $s.configure[target]['dpi'][index] = item == 0 ? 1 : 0;
      };
      $s.selectOutputDir = function (target) {
        bridge.call('select_dir', {}, function (result) {
          console.log(result);
          $s.configure[target]['output'] = result;
          $s.$apply();
        });
      };
      $s.openOutputDir = function (target) {
        var output = $s.configure[target]['output'];
        if (output == '') {
          return;
        }
        bridge.call('open_dir', output, function () {
        });
      };
      $s.formatOutput = function (path) {
        return path.replace(/.*\//, '');
      };
      $s.goSetting = function () {
        $s.$emit('GO_SETTING');
      };
      $s.goUser = function () {
        $s.$emit('GO_USER');
      };
      function checkUpdate() {
        var url = 'https://www.cutterman.cn/client/checkupdate';
        $.post(url, {
          app: APP_NAME,
          version: VERSION_CODE,
          uid: User.uid
        }, function (result) {
          if (result.errno == 0) {
            $s.update = result;
            $s.$apply();
          }
        });
      }
      $s.updateapp = function () {
        bridge.call('open_browser', $s.update.download_url, function () {
        });
      };
      $s.skip = function () {
        $s.update.update = 0;
      };
      init();
    }
  ]);